// YoSoyYo.cpp (C) 2005 adolfo@di-mare.com

#include <iostream>     
// #include "ADH_port.h"

/* NOTA: Paradjicamente, si la clase "Base" contiene un mtodo virtual,
         "YoSoyYo()" en este caso, aunque en las clases  derivadas no sea
         declarado como "virtual" el compilador lo fuerza a serlo.
         - Ms bien el compilador debiera emitir, al menos, un error leve
           (warning), para avisarle al programador que lo que "parece" un
           mtodo esttico, en realida no lo es.

         - "Juegue" con este programa, quitando y poniendo la palabra
           "virtual" para ver qu sucede.

   http://www.di-mare.com/adolfo/cursos/2004-1/p2-ea-f.htm#YoSoyYo
*/

using namespace std;

class Base {
public:
    virtual void YoSoyYo() { cout << "Base" << endl; }
}; // Base


class Hija : public Base {
public:
    void YoSoyYo() { cout << "Hija" << endl; }
}; // Hija

class Hijo : public Base {
public:
    void YoSoyYo() { cout << "Hijo" << endl; }
}; // Hijo


int main()  {

    Base B;
    Hijo el;
    Hija ella;

    Base* Vec[3] = { &B, &el, &ella };

    for (int i=0; i<3; ++i) {
        cout << "VEC[" << i << "] ==> ";
        Vec[i]->YoSoyYo();
    }
    cout << endl;

    return 0;
} // main()

// EOF: YoSoyYo.cpp
